• 2006 ACM Northwestern European Programming Contest C题(二分求最大)


    My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a numberN of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets a piece of pie. This should be one piece of one pie, not several small pieces since that looks messy. This piece can be one whole pie though.

    My friends are very annoying and if one of them gets a bigger piece than the others, they start complaining. Therefore all of them should get equally sized (but not necessarily equally shaped) pieces, even if this leads to some pie getting spoiled (which is better than spoiling the party). Of course, I want a piece of pie for myself too, and that piece should also be of the same size.

    What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and they all have the same height 1, but the radii of the pies can be different.

    Input

    One line with a positive integer: the number of test cases. Then for each test case:

    • One line with two integers N and F with 1 ≤N, F ≤ 10000: the number of pies and the number of friends.
    • One line with N integers ri with 1 ≤ri ≤ 10000: the radii of the pies.

    Output

    For each test case, output one line with the largest possible volumeV such that me and my friends can all get a pie piece of size V. The answer should be given as a floating point number with an absolute error of at most 10-3.

    Sample Input

    3
    3 3
    4 3 3
    1 24
    5
    10 5
    1 4 2 3 4 5 6 5 4 2
    

    Sample Output

    25.1327
    3.1416
    50.2655
    
    The 2006 ACM Northwestern European Programming Contest 


    题意:有F+1个人来分圆形的派,每人只能分一整块,不能几块拼起来,且面积相同,求每人最多分到多大的派(不必是圆形,但是要一整块)
    思路:问题其实就是是否让每人分到一块面积为x的派,我们可以尝试着去试这个x,直到x太大,不能分给F+1个人为止,所以二分法又派上用场了,二分法真正思想其实很博大精深,不是说你会用二分法查找有序列里的一个数你就会二分法了,其实还在门外,好了这道题对于这里的半径为r的派,只能切出PI*r*r* / x个派,把所有的圆切一遍,再判断是否够分就可以了。

    #include <iostream>
    #include <cmath>
    using namespace std;
    
    #define MAX(a, b) ((a) > (b) ? (a) : (b)) 
    
    const int maxn = 10010;
    const double PI = acos(-1.0);
    double s[maxn];
    int n, f, r;
    
    int ok(double x)
    {
    	int sum = 0;
    	for (int i = 0; i < n; i++) sum += floor(s[i] / x);
    	return sum >= f + 1;
    }
    
    int main()
    {
    	int T;
    	cin>>T;
    	while (T--)
    	{
    		cin>>n>>f;
    		double max = -1;//找最大圆的面积
    		for (int i = 0; i < n; i++)
    		{
    			cin>>r;
    			s[i] = PI * r * r;
    			max = MAX(max, s[i]);
    		}
    
    		//二分找最大
    		double L = 0, R = max;
    		while (R - L > 1e-5)
    		{
    			double M = (L + R) / 2;
    			if (ok(M)) L = M;
    			else R = M;
    		}
    		printf("%.5lf
    ", L);
    	}
    	return 0;
    }





  • 相关阅读:
    javascript与CSS复习(《精通javascript》)
    javascript改进表单
    javascript与CSS复习(三)
    javascript dom代码应用:简单的相册
    重新发明轮子之Draggable Elements
    《精通javascript》5,6章复习(三)
    我的JAVA之旅(五)继承
    全面学习DBMS包之UTL_FILE
    想法
    生活在上海
  • 原文地址:https://www.cnblogs.com/riasky/p/3464792.html
Copyright © 2020-2023  润新知